// C Source File
// Created 16/10/2003; 21:05:23

// full optimization : 29/11/2003 --> 657 bytes instead of 1217

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
#define RETURN_VALUE
#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	ESI argPtr;
	InitArgPtr(argPtr);
	if(ArgCount()!=2 || GetArgType(argPtr)!=POSINT_TAG)goto error;
	int nb=GetIntArg(argPtr);

	if(GetArgType(argPtr)!=POSINT_TAG)goto error;
	int base=GetIntArg(argPtr);

	char nbFin[20];
	int pos=19;
	int quotient=1;
	int res;
	while (quotient>0){
		quotient=(int)nb/base;
		res=(int)fmod((float)nb, (float)base);
		nb=quotient;
		switch(res){
			case 0 ... 9:	nbFin[pos--]=48+res; break;
			case 10 ... 35 : nbFin[pos--]=res+55; break;
			default : nbFin[pos--]='?'; break;
		}
	}
	goto end;
	error:
		ST_showHelp("Usage : dec2xx(int nb, int base)");
		push_longint(-1);
		return;
	end:
		push_zstr(&nbFin[++pos]);
		return;
}
